//
// C++ Implementation: cexpresolver
//
// Description: Variable/function resolver for the expression parser.
//
//
// Author: Tomas Mecir <kmuddy@kmuddy.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "cexpresolver.h"

#include "cactionmanager.h"
#include "cmacromanager.h"
#include "cvariablelist.h"

#include <klocale.h>

cExpResolver::cExpResolver (int _sess)
{
  sess = _sess;
  vars = 0;
}

cValue cExpResolver::get (QString varName)
{
  if (!vars)
    vars = dynamic_cast<cVariableList *>(cActionManager::self()->object("variablelist", sess));
  if (vars)
    return *(vars->value(varName, queue));
  return cValue::empty();
}

cValue cExpResolver::function_call (const QString &functionName, list<cValue> &arguments)
{
  if (!cMacroManager::self()->functionExists (functionName)) {
    cActionManager::self()->invokeEvent ("message", sess,
        i18n ("Function %1 does not exist - assuming empty return value.").arg (functionName));
    return cValue::empty();
  }
  return cMacroManager::self()->callFunction (functionName, arguments, sess, queue);
}

